#! /bin/tcsh -f

set PERSOLV='~/bin/persolv1'
set PSD='~/nme/c_vers1/psd'
set PDIR='~/maurizio/eqprem_a'

setenv PERSOLVDIR $PDIR
setenv PERSOLVINPUT "/afs/ir/users/m/o/mordecai/maurizio/eqprem_a/"

set gridfile = 'grid_T3.def'
set statfile = 'grid_T3.dat'
set workdir  = grid_T3
set imax     = 6
set i        = 1

# create directories

mkdir $workdir ;
echo -n > $statfile ;

while( $i <= $imax )
 rm -f $workdir/* ;
 cp -f $gridfile $workdir/params.def ;
 cd $workdir ;
 echo 'NA' > msd.dat ;
 
 # initialize price derivatives with REE solutions

 echo "CaseNo=$i; nOrder=1;" | $PERSOLV - $PDIR/REE.in ;
 echo "CaseNo=$i; nOrder=1;" | $PERSOLV - $PDIR/prices0.in ;

 # Compute Stationary measure and Beliefs

 echo "CaseNo=$i;" | $PSD - $PDIR/statmeas.in ;
 echo "CaseNo=$i; AgentNo = 1;" | $PSD - $PDIR/beliefs.in ;
 echo "CaseNo=$i; AgentNo = 2;" | $PSD - $PDIR/beliefs.in ;

 # initialize agents derivatives

 echo "CaseNo=$i; AgentNo=1; nOrder=1;" | $PERSOLV - $PDIR/agent0.in ;
 echo "CaseNo=$i; AgentNo=2; nOrder=1;" | $PERSOLV - $PDIR/agent0.in ;
 
 # solve for agents derivatives

 echo "nOrder=2; CaseNo=$i;" | $PSD - $PDIR/agent.in ;

 # doing simulations 

 echo "CaseNo=$i; nOrder=2; eps_in=$1;" | $PERSOLV - $PDIR/all.in
 echo "CaseNo=$i; nOrder=2; eps_in=$1;" | $PERSOLV - $PDIR/simu.in
 
 cp -f $PDIR/grid.tsp grid.tsp
 tsp grid.tsp

 echo "CaseNo = $i" >> ../$statfile ;
 cat msd.dat >> ../$statfile ;
 echo >> ../$statfile ;

 set i=`expr $i + 1` ;
 cd .. ;

end

rm -f grid_T3.htm ;

perl grid_T3.pl > grid_T3.htm

netscape grid_T3.htm


exit ;
