#!/usr/bin/perl

#http://www.the7soft.com/file-formats/file-formats-Text/file-formats.html

$title = 'Table 4: The Combined effect of  intensity and asymmetry';
$titletex = 'The Combined effect of  intensity and asymmetry';
$datafile = 'grid_T4.dat' ;
@a = ('-0.05', '-0.10', '-0.15', '-0.20', '-0.25', '-0.30', '-0.35') ;
@b = ('-5.0', '-9.0', '-13.0', '-14.0', '-14.5', '-15.0', '-15.5') ;
$imax = 7 ;
$jmax = 7 ;

open(FILE,"$datafile");
@LINES = <FILE>;
close(FILE);

$string = join(' ',@LINES);
$string =~ s/\n//g;

@records = split(/\s*CaseNo = [0-9]+\s*/,$string) ;

write_table_tex() ;
#write_table_htm() ;


exit ;


sub write_table_tex {
    write_tabhead_tex() ;
    for($i = 0; $i < $imax; $i++) {
	write_rowhead_tex() ;
	for($j = 0; $j < $jmax; $j++) {
	    $idx = 1 + $i + $j*$imax ;
	    print "&\n";
	    write_rec_tex($records[$idx]) ;	
	}
	print "\\\\ \\hline\n";
    }
    write_tabtail_tex() ;
}

sub write_tabhead_tex {
    print "\\documentclass{article}\\begin{document}\n" ;
    print "\\begin{table}\\centering\n";
    print "\\caption{$titletex}\n";
    print "\\begin{tabular}{|c|c|c|c|c|c|c|c|c|}\\hline\n&";
    for($j = 0; $j < $jmax; $j++) {
	print "& \$b=$b[$j]\$ ";
    }
    print "\\\\ \\hline\n" ;
}

sub write_tabtail_tex {
    print "\\end{tabular}\n" ;
    print "\\end{table}" ;
    print "\\end{document}\n" ;
}

sub write_rowhead_tex {
    print "\\begin{tabular}{l}\$a=$a[$i]\$\\end{tabular}\n" ;
    print "&\n";
    print "\\begin{tabular}{l}\$P/D\$\\\\" ;
    print "\$\\sigma_{P/D}\$\\\\" ;
    print "\$R\$\\\\" ;
    print "\$\\sigma_{R}\$\\\\" ;
    print "\$r_f\$\\\\" ;
    print "\$\\sigma_{r_f}\$\\\\" ;
    print "\$ep\$\\\\" ;
    print "\$corr(R,x)\$\\\\" ;
    print "\$Sharpe\$\\\\\\end{tabular}\n" ;
}
sub write_rec_tex {
    $string = $_[0] ;
    ($NOB,$PD,$R,$rf,$ep,$SPD,$SR,$Srf,$Sep,$corr,$sha)
    	= split(/\s+/,$string) ;
    if(defined($R)) {
	printf 
	"\\begin{tabular}{c}%1.2f\\\\%1.2f\\\\%1.2f\\\\%1.2f\\\\%1.2f\\\\%1.2f\\\\%1.2f\\\\%1.2f\\\\%1.2f\\end{tabular}\n",
        $PD,$SPD,$R,$SR,$rf,$Srf,$ep,$corr,$sha;
    } else {
	print "\\begin{tabular}{c}unstable\\end{tabular}\n" ;
    }
}


sub write_table_htm {
    write_tabhead_htm() ;
    for($i = 0; $i < $imax; $i++) {
	write_rowhead_htm() ;
	for($j = 0; $j < $jmax; $j++) {
	    $idx = 1 + $i + $j*$imax ;
	    write_rec_htm($records[$idx]) ;	
	}
	print "</tr>\n";
    }
    write_tabtail_htm() ;
}
sub write_tabhead_htm {
    print "<html><body>\n" ;
    print "<h3>$title</h3>\n" ;
    print "<table border=1><tr align=center valign=middle><td>&nbsp;<td>&nbsp;";
    for($j = 0; $j < $jmax; $j++) {
	print "<td>b = $b[$j]";
    }
    print "</tr>\n" ;    
}
sub write_tabtail_htm {
    print "</table>\n" ;
    print "</body></html>\n" ;
}
sub write_rowhead_htm {
    print "<tr align=left valign=middle><td>a = $a[$i]\n" ;
    print "<td>P/D       <br>sd(P/D)<br>
               R         <br>sd(R)<br>
               rf        <br>sd(rf)<br>
               ep        <br>
               corr(x,R) <br>
               Sharpe    <br>\n";
}
sub write_rec_htm {
    $string = $_[0] ;
    ($NOB,$PD,$R,$rf,$ep,$SPD,$SR,$Srf,$Sep,$corr,$sha)
	= split(/\s+/,$string) ;
    if(defined($R)) {
	printf 
	"<td align=center>%1.2f<br>%1.2f<br>%1.2f<br>%1.2f<br>%1.2f<br>%1.2f<br>%1.2f<br>%1.2f<br>%1.2f\n",
	$PD,$SPD,$R,$SR,$rf,$Srf,$ep,$corr,$sha;
    } else {
	print "<td>unstable\n" ;
    }
}
